
#include <PalmOS.h>
#include <VfsMgr.h>
#include <PalmOSGlue.h>
#include "pnobridge.h"
#include "host68k.h"
#include "endianutils.h"
#include "stdfile.h"
#include "pnaTemplateRsc.h"
#include "display68k.h"
#include <PenInputMgr.h>

UInt32 hw_flags = 0;

UInt8 hw_guess_screen_dimensions ( UInt16 *r_width, UInt16 *r_height,
				   UInt16 *r_pitch )
{
  /* WAIT; OS5 has WinScreenGetAttribute; life is good. */
  /* Process:
   * OS < 5
   *   ZOT requires OS5.
   *   Sony?
   *     If Sony, check Sony API .. its either low res, or we can ask API
   *   Non-Sony
   *     Is it a T|W? It should have DIA..
   *     If DIA, ask it.
   *     Otherwise, low res, bail.
   * OS >= 5
   *   DIA?
   *     If so, ask it.
   *   No DIA, so.. Sony?
   *     If Sony, ask it.
   *   No DIA, No Sony...
   *     Is it Treo? IF slo, low res
   *     If not Treo, must be high res (T|T1, T|T2)
   * Now, if new low res OS5 device comes out.. sucks.
   */
  UInt16 pitch;
  Coord width;
  Coord height;

#if 0
  // is it ARM? 
  if ( ! hw_query_arm() ) {
    // not ARM, must be pre-OS5
    return ( 0 );
  }
#endif

  // Its OS5 at least



	WinHandle winh;
	BitmapType *winb;
	winh = WinGetDisplayWindow();
	winb = WinGetBitmap ( winh );	
	
	
	BmpGetDimensions(winb,&width,&height,&pitch);
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	WinGetDisplayExtent(&width,&height);
	WinPopDrawState();
	
	pitch>>=1;

//i can't get this to compile --tinnus


  // Do we see a DIA present? (T|T3, Zodiac, UX50, Garmin, later devices..)
  {
    UInt32 version;
    Err err = FtrGet ( pinCreator, pinFtrAPIVersion, &version );
    if ( ! err && version ) {
      //PINS exists
      //DEBUGS("PIN present");
      hw_flags |= hf_pin_present;
      
//      if (PINGetInputAreaState()==pinInputAreaOpen) height=320;
//      else height=450;
    } // pin?
    
    
  } // DIA PIN?

  // done
  *r_width = width;
  *r_height = height;
  *r_pitch = pitch;

  return ( 1 );
}

void hw_show_grafitti ( UInt8 grafittip ) {

//i can't get this to compile --tinnus


  if ( grafittip ) {

    if ( hw_flags & hf_pin_present ) {
      PINSetInputAreaState ( pinInputAreaOpen );
    }

  } else {

    if ( hw_flags & hf_pin_present ) {
      PINSetInputAreaState ( pinInputAreaClosed );
    }

  }

  return;
}

void hw_set_fullscreen ( UInt8 fullscreenp ) {


  if ( fullscreenp ) {

    if ( hw_flags & hf_pin_present ) {
      StatHide();
    }

  } else {

    if ( hw_flags & hf_pin_present ) {
      StatShow();
    }

  }

  return;
}

void hw_set_FullscreenGraf(UInt32 fs){
	if (fs) {hw_show_grafitti(0);hw_set_fullscreen(1);}
	else {hw_show_grafitti(1);hw_set_fullscreen(0);}
}