
#ifndef h_pnobridge_h
#define h_pnobridge_h

#define VERSION_MAJOR "1"
#define VERSION_MINOR "0"
#define VERSION_DB 0x0100  //0xMMmm  M Major, m minor

// register your own at http://www.palmos.com/dev/creatorid/
/*#define appName					"Little John for PalmOS"
#define appFileCreator			'LJPM'
#define appVersionNum			0x09
#define appPrefID				0x00
#define appPrefVersionNum		0x09
*/
#define CREATORID 'strt'
#define VFSPATH "/PALM/Programs/PNA_Template/"
#define VFSROOT "/PALM/Programs/"

// 240*160 -> 480*320
#define _PEN_ADJUST_FACTORX_ 2
#define _PEN_ADJUST_FACTORY_ 2


//#define AUDIO_ARM      1 /* if audio-arm defined, then do arm callback */
//#define AUDIO_VOLUME 20 /* see audio_volume(); *64 */

// debug in pno?
//#define PNODEBUG 1

typedef struct {
  UInt32 vfs_max; // number of VFS volumes available
  UInt32 vfs_vol; // volume we actually want to use
  UInt32 vram;    // address of screen VRAM
  UInt32 eventf;  // function pointer to 68k func to do event handling
  UInt32 display_pitch;  // screenbuffer width
  UInt32 display_width;  // X width of display
  UInt32 display_height; // Y height of display
  UInt32 game_rom;       // pointer to chosen game rom filename
  UInt32 audio_buf;      // pointer to audio buffer
  UInt32 flags;          // flags for pnolet
  UInt32 stack;
} pnobridge_t;

// for requesting data from the 68k side, from the pnolet
#define BRIDGESHIFT 6
#define BRIDGEMASK  0x3F
enum {
  BRIDGE_MemGluePtrNew = 1,
  BRIDGE_debugu32, 
  BRIDGE_printfu32,
  BRIDGE_accum,
  BRIDGE_debugs,
  BRIDGE_printfs,
  BRIDGE_error,
  BRIDGE_progress,
  BRIDGE_setaudio,
  BRIDGE_bigalloc,
  BRIDGE_get_skip,
  BRIDGE_bigfree,
  BRIDGE_zodiacblit,
  BRIDGE_max,
  BRIDGE_menu_button,
  BRIDGE_menu_bar,
  BRIDGE_menu_message,
  BRIDGE_menu_messageRaw,
  BRIDGE_filter_event,
  BRIDGE_handle_sysevent,
  BRIDGE_SndStreamCreate,
  BRIDGE_SndStreamDelete,
  BRIDGE_SndStreamStart,
  BRIDGE_SndStreamStop,
  BRIDGE_SndStreamGetVolume,
  BRIDGE_SndStreamSetVolume,
  BRIDGE_Fullscreen,
  BRIDGE_BatteryInfo,
  BRIDGE_SndStreamCreateExtended,
  BRIDGE_BatteryInfo2,
  BRIDGE_DrawBeltBar
};

// bridge options going into the pno
#define BF_FULLSCREEN 1
#define BF_AUDIO      2
#define BF_LOWMEM     4
#define BF_ZODIAC     8
#define BF_HIRESPLUS  16
#define BF_PLAYMOD    16
#define BF_STOPMOD    32
#define BF_INITMOD    64
#define BF_FREEMOD    128

#define BF_UNZIP	  1

#define BF_INIT_GFX	  1
#define BF_DEINIT_GFX 2

#define BF_HASPIN	  256

// for calling back from pno to host
typedef struct {
  UInt32 a;
  UInt32 b;
  UInt32 c;
  UInt32 d;
} hostcall_t;

typedef struct {
  UInt32 a;
  UInt32 b;
  UInt32 c;
  UInt32 d;
  UInt32 e;
  UInt32 f;
  UInt32 g;
  UInt32 h;
  UInt32 i;
} bighostcall_t;

// returning status from event check; buttons and other stuff..
enum {
  STAT_left = 1,
  STAT_right = 2,
  STAT_up = 4,
  STAT_down = 8,
  STAT_fire1 = 16,
  STAT_fire2 = 32,
  STAT_exeunt = 64,
  STAT_pause = 128,
  STAT_start = 256,
  STAT_skip = 512,
  STAT_max
};

// go to 68k side and ask it to do events, returning the goods
UInt32 host_events ( UInt32 foo );
void *GetObjectPtr ( UInt16 objectID );

extern pnobridge_t *g_pnobridge;

#endif
