#ifdef _SUPPORT_ZODIAC_


#include <Tapwave.h>
//#include <PalmOS.h>
#include <VfsMgr.h>
//#include <PalmOSGlue.h>
#include "pnaTemplateRsc.h"

#include "endianutils.h"
#include "host68k.h"

#include "zodiac.h"

#include "App_Cst.h"

#include "ljp_pnoload.h"
#include "pnobridge.h"



TwGfxType *lib = NULL;
TwGfxInfoType ginfo,*ginfo_ptr;

UInt8 g_zodiac = 0;
TwGfxSurfaceType *g_display_surface;
TwGfxSurfaceType *g_backbuffer_surface;



UInt8 tw_gfx_init ( void ) {
  Err error;
  TwGfxSurfaceInfoType surfInfo;

  // prepare TW necessities..


  // prepare for call
  ginfo.size = sizeof(ginfo);

//DEBUGS("prepare for call");

  // set up the API
#ifdef _ZODIAC_NOSIGN_

//  FtrSet(CREATORID, FTR_ZNOSIGN_GINFO_ID ,(unsigned long)(&ginfo));
  {
	//error = TwGfxOpenNoSign ( &lib, &ginfo );
	
	//load no-sign PNO
	MemHandle memh;
	MemPtr ptr;
	PnoDescriptor pno;
	UInt32 res,ret;
	pnobridge_t *bridge;	
	UInt16 pitch, width, height;

	memh = DmGetResource('yPNA', PNA_ZNOSIGN);
	if (!memh) {DEBUGS("Error while accessing znosign resource");return 1;}

	ptr = MemHandleLock(memh);

	if (!ptr){DEBUGS("Error while locking znosign resource");return 2;}	

	res=ljp_PnoLoad ( &pno, ptr,MemPtrSize(ptr) );
    if (res) {DEBUGS("Error while loading znosign pno");return 3;}
    FtrPtrFree ( CREATORID, FTR_PNO );     
	//read memory to flush D cache
	FLUSH_D_CACHE

    bridge = (pnobridge_t*) MemPtrNew ( sizeof(pnobridge_t) );
    hw_guess_screen_dimensions ( &width, &height, &pitch );
    bridge -> vfs_max = palm_vfs_count();
    bridge -> vfs_vol = palm_vfs_iter();
    bridge -> vram = (UInt32) hw_query_vram();
    bridge -> eventf = (UInt32) host_event_handler;
    bridge -> display_width = width;
    bridge -> display_height = height;
    bridge -> display_pitch = pitch;
    bridge -> game_rom = (unsigned long)0;
    bridge -> audio_buf = (unsigned long)(&ginfo);
    bridge -> flags = BF_INIT_GFX;

    if (res=ljp_PnoCall ( &pno, bridge )) {DEBUGS("Error while starting Zodiac lib");DEBUGU32(res);return 4;}
    
    
    FtrGet(CREATORID,FTR_ZNOSIGN_LIB_ID ,(unsigned long*)&lib);
	FtrGet(CREATORID,FTR_ZNOSIGN_GINFO_ID ,(unsigned long*)&ginfo_ptr);
	FtrGet(CREATORID,FTR_ZNOSIGN_RET_ID ,(unsigned long*)&ret);
	 	
  	ginfo.size=ByteSwap32(ginfo_ptr->size);
  	ginfo.displayWidth=ByteSwap32(ginfo_ptr->displayWidth);
  	ginfo.displayHeight=ByteSwap32(ginfo_ptr->displayHeight);
  	ginfo.displayRowBytes=ByteSwap32(ginfo_ptr->displayRowBytes);
  	ginfo.displayPixelFormat=ByteSwap32(ginfo_ptr->displayPixelFormat);
  	ginfo.freeAcceleratorMemory=ByteSwap32(ginfo_ptr->freeAcceleratorMemory);
  	ginfo.totalAcceleratorMemory=ByteSwap32(ginfo_ptr->totalAcceleratorMemory);  				
	        
    bridge -> flags = BF_DEINIT_GFX;
    
    if (res=ljp_PnoCall ( &pno, bridge )) {DEBUGS("Error while starting Zodiac lib");DEBUGU32(res);return 4;}
    MemPtrFree(bridge);
	//unload pno

	res=ljp_PnoUnload ( &pno );    		
    if (res) {DEBUGS("Error while unloading PNO(NOSIGN), probably not enough free ram.");}
   // rearrange memory
   
    FtrUnregister(CREATORID,FTR_ZNOSIGN_LIB_ID);
    FtrUnregister(CREATORID,FTR_ZNOSIGN_GINFO_ID);
    FtrUnregister(CREATORID,FTR_ZNOSIGN_RET_ID);
		 		
	MemHandleUnlock(memh);
	DmReleaseResource(memh);
	
	garbage_collect();
	error=0;
	
  }
#else
	error = TwGfxOpen ( &lib, &ginfo );
#endif

  if ( error ) {
    return ( 1 );
  }
  
//DEBUGS("get disp surf");

  // get physical display surface
  error = TwGfxGetDisplaySurface ( lib, &g_display_surface );

  if ( error ) {
  	DEBUGS("can't get display surf");
  	DEBUGU32(error);
    return ( 2 );
  }

//DEBUGS("create backbuffer");

  // create a backbuffer surface (to blit from)
  surfInfo.size = sizeof(surfInfo);
  surfInfo.width = 480;//ginfo.displayWidth;
  surfInfo.height = 320;//ginfo.displayHeight;
  surfInfo.location = twGfxLocationAcceleratorMemory;
  surfInfo.pixelFormat = twGfxPixelFormatRGB565;
  error = TwGfxAllocSurface ( lib, &g_backbuffer_surface, &surfInfo );

  if ( error ) {
    return ( 3 );
  }
  
// DEBUGS("success");

  return ( 0 );
}

void tw_gfx_close ( void ) {
  // free backbuffer
  TwGfxFreeSurface ( g_backbuffer_surface );

  TwGfxClose ( lib );


  return;
}

void tw_gfx_blit ( UInt16 w,UInt16 h ) {
  Err error;

  // bounds
  TwGfxPointType zeropoint;
  TwGfxRectType rect;   // source

  zeropoint.x = (w-ginfo.displayWidth)>>1;
  zeropoint.y = (h-ginfo.displayHeight)>>1;

  rect.x = 0;
  rect.y = 0;
  rect.w = w;
  rect.h = h;

  // blit backbuffer to screen
  // blit backbuffer to screen
  TwGfxAsyncBlt ( g_display_surface, &zeropoint,
		     g_backbuffer_surface, &rect);  
  return;
}

void tw_gfx_blit2 ( UInt16 width, UInt16 height, UInt16 scale_smooth ) {
  Err error;

  // bounds
  TwGfxPointType zeropoint;
  TwGfxRectType rect;   // source
  TwGfxRectType drect;  // destination
  char tmp[64];

  zeropoint.x = 0;
  zeropoint.y = 0;

  rect.x = 0;
  rect.y = 0;
  rect.w = width;
  rect.h = height;

  switch (scale_smooth&3){
  	case 0:	  
	  drect.w = width*5/4;
	  drect.h = height*5/4;
	  break;
	case 1:
   	  drect.w = 480;//ginfo.displayWidth;
	  drect.h = 320;//ginfo.displayHeight;
	  break;
	case 2:
	  drect.w = 160*2;
	  drect.h = 144*2;
	  break;
	case 3:
	  drect.w = 224*2;//ginfo.displayWidth;
	  drect.h = 144*2;//ginfo.displayHeight;
	  break;
	case 4:
   	  drect.w = 480;//ginfo.displayWidth;
	  drect.h = 320;//ginfo.displayHeight;
	  break;
  }


  drect.x = (ginfo.displayWidth-drect.w)>>1;
  drect.y = (ginfo.displayHeight-drect.h)>>1;
  if (scale_smooth&4)  TwGfxStretchBlt2 ( g_display_surface, &drect,
		     g_backbuffer_surface, &rect,
		     twGfxStretchFast | twGfxStretchSmooth );
	else  TwGfxStretchBlt2 ( g_display_surface, &drect,
		     g_backbuffer_surface, &rect,
		     twGfxStretchFast  );

  return;
}

Boolean TwCheckAPIVersion ( UInt32 minVersion ) {
  UInt32 version;
  FtrGet ( twFtrCreator, twFtrAPIVersion, &version );
  return ( version >= minVersion );
}

UInt8 is_zodiac ( void ) {

  if ( TwCheckAPIVersion ( TAPWAVE_API_VERSION ) ) {
    return ( 1 );
  }

  return ( 0 );
}

UInt32 tw_gfx_lock ( void ) {
  void *x;
  Err error;

  error = TwGfxLockSurface ( g_backbuffer_surface, &x );

  if ( error ) {
  	DEBUGS("Cannot lock surface");
  	DEBUGU32(error);
    return ( NULL );
  }

  return ( (UInt32) x );
}

void tw_gfx_unlock ( void ) {
  TwGfxUnlockSurface ( g_backbuffer_surface, true );
  return;
}

#endif