#define __STACK_SIZE__ 256*1024 //256*1024

#include "math.h"

#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "pnaTemplateRsc.h"

#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

#include "App_Cst.h"
//#include "cossintab.h"

// conveniance pointers
UInt32 display_pitch,display_height,display_width;
UInt32 device_type;
UInt32 ticks_per_sec;
UInt32 currentOwnerID;
UInt32 ljp_showFPS=1;
UInt32 ljp_showBeltbar=1;
UInt32 ljp_showBattMode=1;
UInt32 ljp_isLowRes=0;
UInt32 ljp_confirmOW=1;
UInt32 ljp_confirmSL=1;
char ljp_RomPath[256]="0:"; //IMPORTANT: KEEP THE "0:" IN THERE OR ELSE IT WILL SCREW EVERYTHING! --Tinnus

#define PNO_Main ARMlet_Main

Call68KFuncType * g_my_call68KFuncP;
const void *g_my_emulStateP;
pnobridge_t *g_pnobridge;


#ifdef __PACE__  
UInt32 TimGetTicks ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA0F7 & (0x00000FFF)), 0, 0)));
}

UInt16 SysTicksPerSecond ( void ) {
  return (( UInt16)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2E9 & (0x00000FFF)), 0, 0)));
}

UInt32 KeyCurrentState ( void ) {
  return (( UInt32)((g_my_call68KFuncP)( (void*)(g_my_emulStateP),
					 (0xA2A2 & (0x00000FFF)), 0, 0)));
}
#endif

Int32 GetTickCount()
{
	Int32 l=TimGetTicks();
	return l*1000/ticks_per_sec;
}

// ------------------------

uint32 my_stack,my_stackal,old_stack;
unsigned long pno_result;

  
asm uint32 swap_stack(uint32 new ,uint32 dummy)
{	
	mov  r1,r13
	mov  r13,r0
	mov	 r0,r1
	bx	 lr
}


unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP);
	
SysAppInfoPtr SysGetAppInfo(SysAppInfoPtr *uiAppPP, SysAppInfoPtr *actionCodeAppPP);	


//extern void free ( void *p );


unsigned long PNO_Main(
	const void *emulStateP, 
	void *userData68KP, 
	Call68KFuncType *call68KFuncP)
{
 // needed before making any OS calls using the 
  // PACEInterface library
#ifdef __PACE__  
  InitPACEInterface ( emulStateP, call68KFuncP );
#endif  


  // my cheap hack to get StrAToI happy without modifying paceinterfacelib
  g_my_call68KFuncP = call68KFuncP;
  g_my_emulStateP = emulStateP;
  g_pnobridge = userData68KP;
  
  //SysAppInfoPtr appInfoP,unusedAppInfoP; 
  //currentOwnerID = SysGetAppInfo(&unusedAppInfoP, & appInfoP)->memOwnerID; 

  g_pnobridge -> vfs_max = ByteSwap32 ( g_pnobridge -> vfs_max );
  g_pnobridge -> vfs_vol = ByteSwap32 ( g_pnobridge -> vfs_vol );
  g_pnobridge -> vram = ByteSwap32 ( g_pnobridge -> vram );
  g_pnobridge -> eventf = ByteSwap32 ( g_pnobridge -> eventf );
  g_pnobridge -> display_width = ByteSwap32 ( g_pnobridge -> display_width );
  g_pnobridge -> display_height = ByteSwap32 ( g_pnobridge -> display_height );
  g_pnobridge -> display_pitch = ByteSwap32 ( g_pnobridge -> display_pitch );
  g_pnobridge -> game_rom = ByteSwap32 ( g_pnobridge -> game_rom );
  g_pnobridge -> audio_buf = ByteSwap32 ( g_pnobridge -> audio_buf );
  g_pnobridge -> flags = ByteSwap32 ( g_pnobridge -> flags );

  display_pitch = g_pnobridge -> display_pitch;
  display_width = g_pnobridge -> display_width;
  display_height = g_pnobridge -> display_height;
  
  device_type = g_pnobridge -> flags & (BF_ZODIAC|BF_HIRESPLUS);
  
  ticks_per_sec = SysTicksPerSecond();
  
/*  if ( g_pnobridge -> flags  & BF_ZODIAC )
    {
    	//get backbuffer
    	(unsigned char *) (UInt16*) stubzodiacblit ( 1 );
    }*/
  
  /*new stack*/
#ifdef __STACK_SIZE__  

  my_stack=(uint32)malloc(__STACK_SIZE__+32);
  my_stackal=my_stack+__STACK_SIZE__;
  my_stackal-=my_stackal&31;

  old_stack=swap_stack(my_stackal,0);
#endif  
  
  pno_result=Run();
  
#ifdef __STACK_SIZE__
  swap_stack(old_stack,0);
//  MemPtrFree((void*)my_stack);
  free((void*)my_stack);
#endif  
  return pno_result;
}


/*void *MemGluePtrNewL ( UInt32 foo ) {
  UInt32 r;
  UInt32 arg;

  arg = BRIDGE_MemGluePtrNew | ( foo << BRIDGESHIFT );
  arg = ByteSwap32 ( arg );

  r = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 4 );

  return ( (UInt8*) r );
}*/

UInt16 palm_vfs_iter ( void ) {
  return ( g_pnobridge -> vfs_vol );
}

UInt16 palm_vfs_count ( void ) {
  return ( g_pnobridge -> vfs_max );
}


  
void stub_menu_button(int X,int Y,char *message,int state,RectanglePtr area,int size)
{
  bighostcall_t data;
  UInt32 arg[2];

  data.a=ByteSwap32((UInt32)X);
  data.b=ByteSwap32((UInt32)Y);
  data.c=ByteSwap32((UInt32)message);
  data.d=ByteSwap32((UInt32)state);
  data.e=ByteSwap32((UInt32)area);
  data.f=ByteSwap32((UInt32)size);

  arg[0] = BRIDGE_menu_button;
  arg[0] = ByteSwap32 ( arg[0] );
  arg[1] = (UInt32)(&data);
  arg[1] = ByteSwap32 ( arg[1] );

  g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
			  

  if (area)
  {
	  area->topLeft.x=ByteSwap16(area->topLeft.x);
	  area->topLeft.y=ByteSwap16(area->topLeft.y);
	  area->extent.x=ByteSwap16(area->extent.x);
	  area->extent.y=ByteSwap16(area->extent.y);
  }

}

void stub_menu_message(char *message)
{
	UInt32 arg[2];

	arg[0] = BRIDGE_menu_message;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(message);
	arg[1] = ByteSwap32 ( arg[1] );

	g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );

}

void stub_menu_bar(int X,int Y,int val,int max,RectangleType *area)
{
	bighostcall_t data;
	UInt32 arg[2];

	data.a=ByteSwap32((UInt32)X);
	data.b=ByteSwap32((UInt32)Y);
	data.c=ByteSwap32((UInt32)val);
	data.d=ByteSwap32((UInt32)max);
	data.e=ByteSwap32((UInt32)area);	
	
	arg[0] = BRIDGE_menu_bar;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );

	g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
	
	area->topLeft.x=ByteSwap16(area->topLeft.x);
  	area->topLeft.y=ByteSwap16(area->topLeft.y);
 	area->extent.x=ByteSwap16(area->extent.x);
 	area->extent.y=ByteSwap16(area->extent.y);

}

void stub_menu_messageRaw(int X,int Y,char *message)
{
	hostcall_t data;
	UInt32 arg[2];

	data.a=ByteSwap32((UInt32)X);
	data.b=ByteSwap32((UInt32)Y);
	data.c=ByteSwap32((UInt32)message);

	arg[0] = BRIDGE_menu_messageRaw;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );

	g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );				

}



UInt32 stub_filter_event(EventType *event)
{
	UInt32 arg[2];

	arg[0] = BRIDGE_filter_event;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(event);
	arg[1] = ByteSwap32 ( arg[1] );

	return g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );	
}

void stub_handle_sysevent(EventType *event)
{
	UInt32 arg[2];

	arg[0] = BRIDGE_handle_sysevent;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(event);
	arg[1] = ByteSwap32 ( arg[1] );

	g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );				
	
}

void stub_fullscreen(int fs){
	UInt32 arg[2];
	arg[0] = BRIDGE_Fullscreen;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(fs);
	arg[1] = ByteSwap32 ( arg[1] );
	g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );	
}

// lame lame lame random number generator
/*UInt32 gRandomSeed;
int rand() 
{
    UInt32 result;

    // Generate the new seed
    gRandomSeed *= 2147001325;
    gRandomSeed += 715136305;

    // Return the random number
    result = gRandomSeed >> 16;

    return result;
}

double cos(double a)
{
	return ((double)fix_cos[((int)(a*512.0/PI))&1023])/65536.0;
}
double sin(double a)
{
	return ((double)fix_sin[((int)(a*512.0/PI))&1023])/65536.0;
}
double tan(double a)
{
	int c,s;
	c=sin(a);
	if (c!=0) return sin(a)/c;
	else return 0;
}
double atan(double a)
{
	return 0;
}*/

/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/

/*float InvSqrt (float x)
{
    float xhalf = 0.5f*x;
    int i = *(int*)&x;
    i = 0x5f3759df - (i >> 1);
    x = *(float*)&i;
    x = x*(1.5f - xhalf*x*x);
    return x;
}


double  sqrt(double  val)
{
	
	return val;
}
*/
signed long long fixed_sqrt (signed long long val)
{
	signed long long xr;      // result register 
    signed long long q2;      // scan-bit register 
    int f;                 // flag (one bit) 

        xr = 0;                         // clear result 
        q2 = 0x4000000000000000;               // higest possible result bit 
        do
        {
          if((xr + q2) <= val)
          {
            val -= xr + q2;
            f = 1;                      // set flag 
          }
          else f = 0;                   // clear flag 
          xr >>= 1;
          if(f) xr += q2;               // test flag 
        } while(q2 >>= 2);              // shift twice 

        return xr;
}

double ljp_sqrt(double x){return sqrt(x);}
double ljp_sin(double x){return sin(x);}
double ljp_cos(double x){return cos(x);}
double ljp_tan(double x){return tan(x);}
double ljp_atan(double x){return atan(x);}





Err stub_SndStreamCreate(SndStreamRef *channel,	/* channel-ID is stored here */
						SndStreamMode mode,			/* input/output, enum */
						UInt32 samplerate,				/* in frames/second, e.g. 44100, 48000 */
						SndSampleType type,				/* enum, e.g. sndInt16 */
						SndStreamWidth width,			/* enum, e.g. sndMono */
						SndStreamBufferCallback func,	/* function that gets called to fill a buffer */
						void *userdata,					/* gets passed in to the above function */
						UInt32 buffsize,				/* preferred buffersize in frames, not guaranteed, use 0 for default */
						Boolean armNative){				/* true if callback is arm native */
	bighostcall_t data;
	Err r;
	UInt32 arg[2];

	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)mode);
	data.c=ByteSwap32((UInt32)samplerate);
	data.d=ByteSwap32((UInt32)type);
	data.e=ByteSwap32((UInt32)width);	
	data.f=ByteSwap32((UInt32)func);	
	data.g=ByteSwap32((UInt32)userdata);	
	data.h=ByteSwap32((UInt32)buffsize);	
	data.i=ByteSwap32((UInt32)armNative);	
	
	
	arg[0] = BRIDGE_SndStreamCreate;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );

	r=g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
	*channel = (SndStreamRef)ByteSwap32((UInt32)(*channel));
	return r;
}							

Err stub_SndStreamDelete(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamDelete;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamStart(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamStart;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamStop(SndStreamRef channel){
	UInt32 arg[2];
	arg[0] = BRIDGE_SndStreamStop;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(channel);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamSetVolume(SndStreamRef channel, Int32 volume){
	UInt32 arg[2];
	hostcall_t data;	
	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)volume);	
	arg[0] = BRIDGE_SndStreamSetVolume;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
}

Err stub_SndStreamGetVolume(SndStreamRef channel, Int32 *volume){
	Int32 arg[2];
	Err r;
	hostcall_t data;	
	data.a=ByteSwap32((UInt32)channel);
	data.b=ByteSwap32((UInt32)volume);
	arg[0] = BRIDGE_SndStreamGetVolume;
	arg[0] = ByteSwap32 ( arg[0] );
	arg[1] = (UInt32)(&data);
	arg[1] = ByteSwap32 ( arg[1] );
	r=g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg[0]), 8 );
	*volume=ByteSwap32((UInt32)(*volume));
	return r;
}

// 0 == lock; 1 == unlock; 2 == blit; 3 == scaled blit with optionnal smooth (s)
UInt32 stubzodiacblit ( UInt32 mode, UInt32 w,UInt32 h,UInt32 s ) {
  Int32 arg[2];
  hostcall_t data;	
  UInt32 ret;
  
  data.a=ByteSwap32(mode);
  data.b=ByteSwap32(w);
  data.c=ByteSwap32(h);
  data.d=ByteSwap32(s);
  arg[0] = BRIDGE_zodiacblit;
  arg[0] = ByteSwap32 ( arg[0] );
  arg[1] = (UInt32)(&data);
  arg[1] = ByteSwap32 ( arg[1] );
	
  ret = g_my_call68KFuncP ( g_my_emulStateP,
			  (UInt32) g_pnobridge -> eventf, &arg, 8 );

  return ( ret );
}

UInt32 stub_BatteryInfo(void){
	UInt32 arg;
	arg = BRIDGE_BatteryInfo;
	arg = ByteSwap32 ( arg );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg), 4 );
}

UInt32 stub_BatteryInfo2(void){
	UInt32 arg;
	arg = BRIDGE_BatteryInfo2;
	arg = ByteSwap32 ( arg );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &(arg), 4 );
}

Err stub_DrawBeltBar(void){
	UInt32 arg;
	arg = BRIDGE_DrawBeltBar;
	arg = ByteSwap32 ( arg );
	return g_my_call68KFuncP ( g_my_emulStateP,(UInt32) g_pnobridge -> eventf, &arg, 4 );
}