#ifndef h_PNOMain_h
#define h_PNOMain_h

#include "pnobridge.h"

#ifdef __PACE__
#define PNA_HANDLE_EVENT(_pause_func) {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					if (_pause_func) _pause_func(1);\
					stub_handle_sysevent(&myevent);\
					if (_pause_func) _pause_func(0);\
				} else break;\
			}\
		}

#define PNA_HANDLE_EVENT_NOFUNC() {\
			EventType myevent; \
			for (;;) {\
				if (stub_filter_event(&myevent)) {\
					stub_handle_sysevent(&myevent);\
				} else break;\
			}\
		}		
#else
#include "palmos5.h"
#define PNA_HANDLE_EVENT(_pause_func) {\
		EventType myevent; \
		EvtFlushKeyQueue();\
		EvtFlushPenQueue();\
		while (SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent:\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
					break;\
				case winExitEvent:\
					_pause_func(1);\
					break;\
				case winEnterEvent:\
					_pause_func(0);\
				case frmUpdateEvent:\
				case winDisplayChangedEvent:{\
					WinHandle winh;\
				    BitmapType *winb;\
					winh = WinGetDisplayWindow();\
					winb = WinGetBitmap ( winh );\
					BmpGetDimensions(winb,&display_width,&display_height,&display_pitch);\
					WinPushDrawState();\
					WinSetCoordinateSystem(kCoordinatesNative);\
					WinGetDisplayExtent(&display_width,&display_height);\
					WinPopDrawState();\
					display_pitch>>=1;\
					g_pnobridge -> display_pitch = display_pitch;\
					g_pnobridge -> display_width = display_width;\
					g_pnobridge -> display_height = display_height;\
					g_pnobridge -> vram =(UInt32)BmpGetBits ( winb );\
					ClearScreen();\
					break;}\
				default:{\
					_pause_func(1);\
					SysHandleEvent(&myevent);\
					_pause_func(0);\
				}\
			}\
		}\
		}
#define PNA_HANDLE_EVENT_NOFUNC()  {\
		EventType myevent; \
		while ( SysEventAvail()) {\
		  	SysEventGet(&myevent,0); \
			if (myevent.eType==nilEvent) break; \
			switch (myevent.eType){\
				case appStopEvent: penDown=1;if (menu_confirm("Exit app ?")) result=2;else result=1;break;\
				case winEnterEvent:\
				case frmUpdateEvent:\
				case penDownEvent:\
				case penUpEvent:\
				case penMoveEvent:\
				case keyDownEvent:\
				case keyUpEvent:\
				case keyHoldEvent:\
				case winExitEvent:\
				case winDisplayChangedEvent:\
				SysHandleEvent(&myevent);break;\
				default:{\
					SysHandleEvent(&myevent);\
				}\
			}\
		}\
		}  

  

#endif	


#define PNA_WAIT(ms) {\
	int i=GetTickCount();\
	while ((GetTickCount()-i)<ms);\
	}
			
extern UInt16 ticks_per_sec;
extern pnobridge_t *g_pnobridge;
extern const void *g_my_emulStateP;
extern UInt16 display_pitch,display_height,display_width;


UInt32 host_events ( UInt32 foo );
int rand(void);

Int32 GetTickCount();

/*double cos(double a);
double sin(double a);
double tan(double a);
double atan(double a);
double sqrt(double a);
*/

Err stub_SndStreamCreate(SndStreamRef *channel,	/* channel-ID is stored here */
						SndStreamMode mode,			/* input/output, enum */
						UInt32 samplerate,				/* in frames/second, e.g. 44100, 48000 */
						SndSampleType type,				/* enum, e.g. sndInt16 */
						SndStreamWidth width,			/* enum, e.g. sndMono */
						SndStreamBufferCallback func,	/* function that gets called to fill a buffer */
						void *userdata,					/* gets passed in to the above function */
						UInt32 buffsize,				/* preferred buffersize in frames, not guaranteed, use 0 for default */
						Boolean armNative);
Err stub_SndStreamDelete(SndStreamRef channel);
Err stub_SndStreamStart(SndStreamRef channel);
Err stub_SndStreamStop(SndStreamRef channel);
Err stub_SndStreamSetVolume(SndStreamRef channel, Int32 volume);
Err stub_SndStreamGetVolume(SndStreamRef channel, Int32 *volume);
Err stub_DrawBeltBar(void);

void stub_fullscreen(int fs);
UInt32 stubzodiacblit ( UInt32 mode, UInt32 w,UInt32 h,UInt32 s );
UInt32 stub_BatteryInfo(void);

#endif
