#include "palmdep.h"
#include "endianutils.h"
#include "pnobridge.h"
#include "oscompat.h"
#include "endianutils.h"

#include "pnaTemplateRsc.h"
#include "App_Cst.h"

#ifdef __PACE__  
#include "PACEInterface.h"
#else
#include "palmos5.h"
#endif

#include "LJZmenu.h"

#include "PNOMain.h"

#include "PenInputMgr.h"

extern char os9x_curVolume;

#define SCREEN_W  (ljp_isLowRes ? 160 : 320)
#define SCREEN_H  (ljp_isLowRes ? 160 : 320)

UInt32 g_screenlock_off=0;
extern UInt32 ljp_isLowRes;


WinHandle ljp_winh=NULL,ljp_offwinh=NULL;
/*uint8 *ljp_WinScreenLock(int mode)
{
	uint8 *result=NULL;
	ljp_winh=WinGetDisplayWindow();
	if (ljp_winh)
	{
	    BitmapType *winb;
	    UInt32 _pitch,_height,_width;
	    UInt16 _error;
		winb = WinGetBitmap ( ljp_winh );
		ljp_offwinh = WinCreateOffscreenWindow(display_pitch>>1,display_height,nativeFormat, &_error);
		if (!_error)
		{
			if (mode==winLockCopy)
			{
				RectangleType srcRect;
				srcRect.topLeft.x=0;srcRect.topLeft.y=0;
				srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
				WinCopyRectangle (ljp_winh,ljp_offwinh,&srcRect,0,0,winErase);
			}
			WinSetDrawWindow(ljp_offwinh);
			winb = WinGetBitmap ( ljp_offwinh );
			result=(uint8*)BmpGetBits ( winb );
		}
	}	
	return result;
}

void ljp_WinScreenUnlock(void)
{
	if (ljp_offwinh)
	{
		BitmapType *winb;
		RectangleType srcRect;
		srcRect.topLeft.x=0;srcRect.topLeft.y=0;
		srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
		WinCopyRectangle (ljp_offwinh,ljp_winh,&srcRect,0,0,winErase);
		WinSetDrawWindow(ljp_winh);
		WinDeleteWindow(ljp_offwinh,false);
		ljp_offwinh=NULL;
	}
}
*/
UInt8 *ljp_WinScreenLock(int mode)
{
	UInt8 *result=NULL;
	UInt32  maxP,freeP;	
	
	if (g_screenlock_off) return NULL;
	
	MemHeapFreeBytes(0,&freeP,&maxP);				
	if ((ljp_offwinh)||(maxP<500*1024)) return NULL; //already locked
	ljp_winh=WinGetDrawWindow();	
	if (ljp_winh)
	{
	    BitmapType *winb;
	    UInt32 _pitch,_height,_width;
	    UInt16 _error;
		if (ljp_isLowRes) {
			ljp_offwinh = WinCreateOffscreenWindow(SCREEN_W,SCREEN_H,nativeFormat, &_error);
		} else {
			ljp_offwinh = WinCreateOffscreenWindow(display_pitch>>1,display_height,nativeFormat, &_error);
		}
		if (!_error)
		{
			if (mode==winLockCopy)
			{
				RectangleType srcRect;
				srcRect.topLeft.x=0;srcRect.topLeft.y=0;
				if (ljp_isLowRes) {
					srcRect.extent.x=SCREEN_W;srcRect.extent.y=SCREEN_H;
				} else {
					srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
				}
				WinCopyRectangle (ljp_winh,ljp_offwinh,&srcRect,0,0,winPaint);
			}
			WinSetDrawWindow(ljp_offwinh);
			winb = WinGetBitmap ( ljp_offwinh );
			result=(UInt8*)BmpGetBits ( winb );
		} else ljp_offwinh=NULL;
	}	
	return result;
}

void ljp_WinScreenUnlock(void)
{
	if (g_screenlock_off) return;

	if (ljp_offwinh)
	{
		BitmapType *winb;
		RectangleType srcRect;
		srcRect.topLeft.x=0;srcRect.topLeft.y=0;
		if (ljp_isLowRes) {
			srcRect.extent.x=SCREEN_W;srcRect.extent.y=SCREEN_H;
		} else {
			srcRect.extent.x=display_pitch>>1;srcRect.extent.y=display_height;
		}
		WinCopyRectangle (ljp_offwinh,ljp_winh,&srcRect,0,0,winPaint);
		WinSetDrawWindow(ljp_winh);
		WinDeleteWindow(ljp_offwinh,false);
		ljp_offwinh=NULL;
	}
}

extern char g_debugbuffer[128];
extern int g_debugbufferpos;

int menu_debug(char *message)
{
/*	FILE *f;
	char filename[64];
	strcpy(filename,"0:/ljp-debug.txt");
	filename[0]=os9x_curVolume+'0';
	f=fopen(filename,"wb");
	if (f)
	{
		char c;
		fseek(f,0,SEEK_END);
		
		fwrite(message,1,strlen(message),f);
		c='\n';
		fwrite(&c,1,1,f);
		fclose(f);
	}*/
	if (message)
	{
		int l,y,pos;
//		menu_confirm(message);
		memcpy(g_debugbuffer+g_debugbufferpos,message,strlen(message));

		g_debugbufferpos+=strlen(message);
		g_debugbuffer[g_debugbufferpos++]='.';
		g_debugbuffer[g_debugbufferpos]=0;		

		y=0;pos=0;
		for (l=(g_debugbufferpos/24)+1;l;l--)
		{
			menu_messageRaw(0,y,g_debugbuffer+pos);
			pos+=24;
			y+=18;
		}
		//PrefSetAppPreferences(CREATORID,FTR_PREF_CRASHINFO_ID,(short)VERSION,(void*)g_debugbuffer,(short)128,(unsigned char)0);

	}
}

int menu_confirm(char *message)
{
	RectangleType ryes,rno;
	int x,y;
	menu_message(message);
	menu_button (160-43-60,200,"Yes",2,&ryes,1);
	menu_button (160-43+60,200,"No",2,&rno,1);
	
	for (;;)
	{
		menu_waitPen(&x,&y,1);
		if (TEST_PEN_MENU(x,y,ryes)) return 1;
		if (TEST_PEN_MENU(x,y,rno)) return 0;
	}
}

void menu_info(char *message){
	RectangleType rok;
	int x,y;
	menu_message(message);
	menu_button (160-43,200,"Ok",2,&rok,1);	
	for (;;)
	{
		menu_waitPen(&x,&y,1);
		if (TEST_PEN_MENU(x,y,rok)) return ;
	}
}

int menu_confirm2(char *message)
{
	RectangleType ryes,rno;
	int x,y;
	menu_message(message);
	menu_button (160-43-60,200,"Yes",2,&ryes,1);
	menu_button (160-43+60,200,"No",2,&rno,1);
	
	for (;;)
	{
		menu_waitPen(&x,&y,0);
		if (TEST_PEN_MENU(x,y,ryes)) return 1;
		if (TEST_PEN_MENU(x,y,rno)) return 0;
	}
}



int menu_getTick(void)
{
	long long l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();
}
void menu_wait(int ms)
{
	int start=menu_getTick();
	while (menu_getTick()-start<ms) ;
}


void menu_messageRaw(int X,int Y,char *message)
{
#ifdef __PACE__
	stub_menu_messageRaw(X,Y,message);
#else
	RGBColorType fg;	
	RectangleType rect;	
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));        
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(message,StrLen(message),X,Y);
	
	WinPopDrawState();
#endif	
}


void menu_message(char *message)
{
#ifdef __PACE__
	stub_menu_message(message);
#else
	RGBColorType fg;	
	RectangleType rect;	
	Int16 width,j;	
	Boolean notruncated;
	char *p;
	
	notruncated=1;
	p=message;
	j=StrLen(p);
	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);

    WinSetDrawMode(winPaint);
    FntSetFont(boldFont);
    
    width=FntCharsWidth(message,StrLen(message));
    
    if (width>300)
    {
	    width=300;
		FntCharsInWidth(message,&width,&j,&notruncated);
		if (!notruncated)
		{
			p=(char*)MemPtrNew(j);
			MemMove(p,message,j);
			p[j]=0;
			p[j-1]='.';p[j-2]='.';p[j-3]='.';
		}
	}
    
   	fg.r=250>>1;fg.g=250>>1;fg.b=250>>1;
    WinSetForeColorRGB(&fg,NULL);                
    rect.topLeft.x=SCREEN_W/2-width/2-5;
    rect.topLeft.y=SCREEN_H/2-FntBaseLine()/2-7;
    rect.extent.x=width+10;
    rect.extent.y=FntBaseLine()+15;
    WinPaintRectangle(&rect,8);
    fg.r=250;fg.g=250;fg.b=250;  
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=SCREEN_W/2-width/2-5+1;
    rect.topLeft.y=SCREEN_H/2-FntBaseLine()/2-7+1;
    rect.extent.x=width+10-2;
    rect.extent.y=FntBaseLine()+15-2;
    WinPaintRectangle(&rect,8);		
    
	WinSetDrawMode(winOverlay);
    fg.r=220;fg.g=180;fg.b=40;
    WinSetTextColorRGB(&fg,NULL);    
	WinPaintChars(p,j,SCREEN_W/2-width/2,SCREEN_H/2-1-FntBaseLine()/2);
	
	
	if (!notruncated) MemPtrFree(p);
	
	WinPopDrawState();

#endif	
}

void menu_button (int X,int Y,char *message,int state,RectanglePtr area,int size)
{	
	
#ifdef __PACE__
	stub_menu_button(X,Y,message,state,area,size);
#else
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    WinSetDrawMode(winPaint);
    
    switch (size)
	{	
		case 2:width=130;break;			
		case 1:width=80;break;
		case 0:width=40;break;				
		case 3:width=30;break;				
		case 4:width=FntCharsWidth(message,StrLen(message))+12;break;		
		case 5:width=200;break;		
	}	
    
    //jbp...
	if (size != 4) {
		width = width;
	}
    
    switch (state)
    {
    	case 0:fg.r=200>>1;fg.g=130>>1;fg.b=150>>1;break;
    	case 1:fg.r=128>>1;fg.g=80>>1;fg.b=0;break;
    	case 2:fg.r=255>>1;fg.g=140>>1;fg.b=0;break;
    	case 3:fg.r=80>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 4:fg.r=160>>1;fg.g=120>>1;fg.b=205>>1;break;
    	case 5:fg.r=240>>1;fg.g=50>>1;fg.b=45>>1;break;
    	case 6:fg.r=35>>1;fg.g=210>>1;fg.b=15>>1;break;
    	case 7:fg.r=220>>1;fg.g=80>>1;fg.b=80>>1;break;
    	case 8:fg.r=30>>1;fg.g=20>>1;fg.b=220>>1;break;
    	case 9:fg.r=255>>1;fg.g=240>>1;fg.b=220>>1;break;
    }
    WinSetForeColorRGB(&fg,NULL);
                
    rect.topLeft.x=X;
    rect.topLeft.y=Y;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6;
    rect.extent.y=FntBaseLine()+12;
    if (area) *area=rect;
    WinPaintRectangle(&rect,8);
     switch (state)
    {
    	case 0:fg.r=170;fg.g=100;fg.b=140;break;
    	case 1:fg.r=128;fg.g=80;fg.b=0;break;
    	case 2:fg.r=255;fg.g=140;fg.b=0;break;
    	case 3:fg.r=80;fg.g=80;fg.b=80;break;
    	case 4:fg.r=160;fg.g=120;fg.b=205;break;
    	case 5:fg.r=240;fg.g=50;fg.b=45;break;
    	case 6:fg.r=35;fg.g=210;fg.b=15;break;
    	case 7:fg.r=220;fg.g=80;fg.b=80;break;
    	case 8:fg.r=30;fg.g=20;fg.b=220;break;
    	case 9:fg.r=255;fg.g=240;fg.b=220;break;
    }
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X+1;
    rect.topLeft.y=Y+1;
    rect.extent.x=/*FntCharsWidth(message,strlen(message))*/width+6-2;
    rect.extent.y=FntBaseLine()+12-2;
    WinPaintRectangle(&rect,8);
		  
    WinSetDrawMode(winOverlay);
    switch (state)
    {    	
    	case 1:
    	case 2:
    	case 3:
    	case 5:
    	case 9:
	    fg.r=32;fg.g=32;fg.b=64;
	    break;
	    case 0:
	    case 4:
	    case 6:
	    case 7:
	    case 8:
	    
	    fg.r=255;fg.g=255;fg.b=255;
	    break;
	}
    WinSetTextColorRGB(&fg,NULL);
	WinPaintChars(message,StrLen(message),X+(width+6-FntCharsWidth(message,StrLen(message)))/2,Y+4);
	
	WinPopDrawState();
#endif	
}

void menu_bar(int X,int Y,int val,int max,RectangleType *area)
{
	//X = (X);
	//Y = (Y);
#ifdef __PACE__
	stub_menu_bar(X,Y,val,max,area);
#else
	RGBColorType fg;
	RectangleType rect;
	int width;	
	
	WinPushDrawState();
	WinSetCoordinateSystem(kCoordinatesNative);
	
    WinSetDrawMode(winPaint);
    
   	fg.r=255>>1;fg.g=250>>1;fg.b=245>>1;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=X;
    rect.topLeft.y=Y+10-3;
    rect.extent.x=100+5;
    rect.extent.y=5;
    WinPaintRectangle(&rect,0);
    
    fg.r=255;fg.g=250;fg.b=245;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=(X+1);
    rect.topLeft.y=(Y+10-3+1);
    rect.extent.x=(100+5-2);
    rect.extent.y=(5-2);
    WinPaintRectangle(&rect,0);
    
    fg.r=250>>1;fg.g=200>>1;fg.b=255>>1;
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=(X+val*100/max);
    rect.topLeft.y=(Y-1);
    rect.extent.x=(8);
    rect.extent.y=(21);
    WinPaintRectangle(&rect,8);
    
    fg.r=250;fg.g=200;fg.b=255;   
    WinSetForeColorRGB(&fg,NULL);
    rect.topLeft.x=(X+val*100/max+1);
    rect.topLeft.y=(Y);
    rect.extent.x=(8-2);
    rect.extent.y=(21-2);
    WinPaintRectangle(&rect,8);
    
    rect.topLeft.x=(X);    
    rect.topLeft.y=(Y);
    rect.extent.x=(100+5);
    rect.extent.y=(21);
    if (area) 
    {
   		if (rect.topLeft.x>=(10)) rect.topLeft.x-=(10);
	  	else rect.topLeft.x=0;
		rect.extent.x+=(20);
    	*area=rect;
	}    
	WinPopDrawState();
#endif	
}

/*int menu_waitPen(int *X,int *Y,int wait_release)
{
	int penX,penY;
	Boolean penDown;
	int redraw=0;
	
   	
   	if (wait_release==3)
   	{
		EvtGetPen(&penX,&penY,&penDown);
		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;						
		return redraw;    
   	}

    if (wait_release)
	do{
   		EvtGetPen(&penX,&penY,&penDown);
	    if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
    } while (penDown);

    if (wait_release==2) 
    {
    	return redraw;    
    }
//unmask    
    KeySetMask(keyBitsAll);
    
	do{		
    	EvtGetPen(&penX,&penY,&penDown);
    	if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
		if (!penDown) LJP_HANDLE_EVENT_NOFUNC()
	} while (!penDown);
//remask	
	KeySetMask(~keyBitsAll);
		
	if (wait_release)
    do{
   		EvtGetPen(&penX,&penY,&penDown);
   		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;	
    } while (penDown);
	return redraw;    
}*/
int menu_waitPen(int *X,int *Y,int wait_release)
{
	Int16 penX,penY,result;
	Boolean penDown;
	result=0;
		   	
   	if (wait_release==3)
   	{
		EvtGetPen(&penX,&penY,&penDown);
		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;						
		return result;
   	}

    if (wait_release)
	do{
   		EvtGetPen(&penX,&penY,&penDown);
	    if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
    } while (penDown);

    if (wait_release==2) 
    {
    	return result;
    }
    
    #ifndef _ZIRE31_KEYS
    KeySetMask(keyBitsAll);
    #endif
    
	do{		
    	EvtGetPen(&penX,&penY,&penDown);
    	if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;
		if (!penDown) PNA_HANDLE_EVENT_NOFUNC()
	} while (!penDown);		
	
	#ifndef _ZIRE31_KEYS_
	KeySetMask(~keyBitsAll);
	#endif
		
	if (wait_release)
    do{
   		EvtGetPen(&penX,&penY,&penDown);
   		if (X) *X=penX*_PEN_ADJUST_FACTORX_;
		if (Y) *Y=penY*_PEN_ADJUST_FACTORY_;	
    } while (penDown);

	return result;    
}

void menu_inform(char* message) {
	menu_message(message);
	menu_waitPen(NULL,NULL,1);
}

