#include <Standalone.h>
#include "../Include/endianutils.h"
#include "../Include/palmos5.h"

#include "Force16_Res.h"

#define RESID 999

#define SWAP32( x ) ( ( ( x ) >> 24 ) | ( ( ( x ) & 0x00FF0000l ) >> 8 ) | ( ( ( x ) & 0x0000FF00l ) << 8 ) |  ( ( x ) << 24 ) )

STANDALONE_CODE_RESOURCE_TYPESTR_ID("armc", RESID);

Boolean Activate( Boolean state )
{
    MemHandle resource;
    LocalID   db;
    Boolean   unregistered;
    
    FtrUnregister( MY_CRID, FTR_CURRENT_APP );

    SysCurAppDatabase( &db );

    unregistered = false;

    if ( errNone == FtrGet( MY_CRID, FTR_LAUNCH_NOTIFICATION_HANDLER_RESOURCE,
            ( UInt32* )&resource ) ) {
        SysNotifyUnregister( db, sysNotifyAppLaunchingEvent, 0 );
        MemHandleUnlock( resource );
        FtrUnregister( MY_CRID, FTR_LAUNCH_NOTIFICATION_HANDLER_RESOURCE );
        unregistered = true;
    }

    if ( state ) {
        void* launchNotificationHandler;

        resource = DmGetResource( 'armc', 998 );

        if ( resource == NULL )
            return false;

        FtrSet( MY_CRID, FTR_LAUNCH_NOTIFICATION_HANDLER_RESOURCE, ( UInt32 )resource );

        launchNotificationHandler = MemHandleLock( resource );

        SysNotifyRegister( db, sysNotifyAppLaunchingEvent,
            launchNotificationHandler,
            0, NULL );

        return true;
    }
    else {
        return unregistered;
    }

}



